#ifndef _OPC_DICTIONARY_H
#define _OPC_DICTIONARY_H


#include <opcfdopcbinarydictionary.h>

typedef void *OPCDictionary;
typedef OPCDictionaryTypeT OPCDictionaryType;

enum OPCDictionaryTypeT {
    OPC_DICTIONARY_OPCBINARY = 0
};

struct OPCDictionary {
    void* (*create)(const char *dictionary);
    void* (*create_memory)(const char *xml, unsigned long length);
    int (*add)(void *ctx, const char *type);
    int (*add_memory)(void *ctx, const char *xml, unsigned long length);
    int (*localize)(void *ctx);
    int (*publish)(void *ctx);
}


OPCDictionary opcDictionaryCreate(OPCContext ctx, OPCDictionaryType type, const char *dictionary);
OPCDictionary opcDictionaryCreateFromMemory(OPCContext ctx, OPCDictionaryType type, const char *xml, unsigned long length);
OPCType opcDictionaryCreateType(OPCDictionary ctx, const char *type);
int opcDictionaryAddType(OPCDictionary ctx, xmlDocPtr doc);
//?int opcDictionaryLocalize(OPDictionary ctx);
int opcDictionaryPublish(OPCDictionary ctx);

#endif /* _OPC_DICTIONARY_H */
