#ifndef _OPC_PROPERTY_H
#define _OPC_PROPERTY_H

#include <hashtable.h>
#include <opcstringlist.h>
#include <opcmalloc.h>

typedef unsigned char OPCSimpleType;
typedef struct OPCPropertyContextT *OPCPropertyContext;
typedef struct OPCPropertyInstanceContextT *OPCPropertyInstanceContext;
typedef struct OPCPropertyT *OPCProperty;

#include <opc.h>

#define opc_properties_maxid	600


struct OPCPropertyInstanceContextT {
    void *item[opc_properties_maxid];
    OPCPropertyContext pctx;
};

struct OPCPropertyT {
    char *name;
    unsigned int id;
    OPCSimpleType type;
    void *attr;			/* Enumerations, Complex Functions */
};

struct OPCPropertyContextT {
    OPCMallocContext malloc;
    HashTable id;
    OPCProperty prop[opc_properties_maxid];
    OPCStringList instances;
};

int opcPropertyInit(OPCContext ctx);

OPCPropertyInstanceContext opcPropertyGetInstance(OPCPropertyContext ctx);
void opcPropertyFreeInstance(OPCPropertyInstanceContext ctx);
void opcPropertyReturnInstance(OPCPropertyInstanceContext ctx);



#define OPC_ITEM_QUALITY_BAD 0
#define OPC_ITEM_QUALITY_BAD_CONFIGURATION_ERROR 1
#define OPC_ITEM_QUALITY_BAD_NOT_CONNECTED 2
#define OPC_ITEM_QUALITY_BAD_DEVICE_FAILURE 3
#define OPC_ITEM_QUALITY_BAD_SENSOR_FAILURE 4
#define OPC_ITEM_QUALITY_BAD_LAST_KNOWN_VALUE 5
#define OPC_ITEM_QUALITY_BAD_COMM_FAILURE 6
#define OPC_ITEM_QUALITY_BAD_OUT_OF_SERVICE 7
#define OPC_ITEM_QUALITY_UNCERTAIN 8
#define OPC_ITEM_QUALITY_UNCERTAIN_LAST_USABLE_VALUE 9
#define OPC_ITEM_QUALITY_UNCERTAIN_SENSOR_NOT_ACCURATE 10
#define OPC_ITEM_QUALITY_UNCERTAIN_EU_EXCEEDED 11
#define OPC_ITEM_QUALITY_UNCERTAIN_SUB_NORMAL 12
#define OPC_ITEM_QUALITY_GOOD 13
#define OPC_ITEM_QUALITY_GOOD_LOCAL_OVERRIDE 14

#define OPC_ITEM_LIMITSTATUS_NONE 0
#define OPC_ITEM_LIMITSTATUS_LOW 1
#define OPC_ITEM_LIMITSTATUS_HIGH 2
#define OPC_ITEM_LIMITSTATUS_CONSTANT 3

#define OPC_ITEM_ACCESSRIGHTS_UNKNOWN 0
#define OPC_ITEM_ACCESSRIGHTS_NONE 0
#define OPC_ITEM_ACCESSRIGHTS_READABLE 1
#define OPC_ITEM_ACCESSRIGHTS_WRITABLE 2
#define OPC_ITEM_ACCESSRIGHTS_READ_WRITABLE 3

#define OPC_ITEM_EUTYPE_NOENUM 0
#define OPC_ITEM_EUTYPE_ANALOG 1
#define OPC_ITEM_EUTYPE_ENUMERATED 2






#endif /* _OPC_PROPERTY_H */
