typedef struct OPCFormatOPCXMLOptionsT *OPCFormatOPCXMLOptions;
struct OPCFormatOPCXMLOptionsT {
    const char *opc_namespace;
    const char *xsi_namespace;
};

int opcFormatOPCXMLInitContext(OPCFormatOPCXMLContext ctx, OPCFormatOPCXMLOptions options);

OPCFormatOPCXMLOptions opcFormatOPCXMLGetDefaultOptions(const char *xsins, const char *opcns);
int opcFormatOPCXMLInitDefaultOptions(OPCFormatOPCXMLOptions ctx, const char *xsins, const char *opcns);
void opcFormatOPCXMLFreeOptions(OPCFormatOPCXMLOptions ctx);
void opcFormatOPCXMLDestroyOptions(OPCFormatOPCXMLOptions ctx);

OPCFormatOPCXMLOptions opcFormatOPCXMLGetDefaultOptions(const char *xsins, const char *opcns) {
    int err;
    OPCFormatOPCXMLOptions options;

    options = (OPCFormatOPCXMLOptions)malloc(sizeof(struct OPCFormatOPCXMLOptionsT));
    if (!options) return options;

    err = opcFormatOPCXMLInitDefaultOptions(options, xsins, opcns);
    if (err) {
	opcFormatOPCXMLDestroyOptions(options);
	return NULL;
    }
    return options;
}

int opcFormatOPCXMLInitDefaultOptions(OPCFormatOPCXMLOptions ctx, const char *xsins, const char *opcns) {
    if (!ctx) return ERR_OPC_PARAM;
    ctx->xsi_namespace = xsins;
    ctx->opc_namespace = opcns;
    return 0;
}

void opcFormatOPCXMLDestroyOptions(OPCFormatOPCXMLOptions ctx) {
    if (ctx) free(ctx);
}

int opcFormatOPCXMLInitContext(OPCFormatOPCXMLContext ctx, OPCFormatOPCXMLOptions options) {
    assert(ctx);
    assert(options);

    printf("%p %p\n",options->opc_namespace,options->xsi_namespace);
    
    if ((!ctx)||(!options)) return ERR_OPC_PARAM;
//    if ((!options->opc_namespace)||(!options->xsi_namespace)) return ERR_OPC_FORMAT_OPCXML_INVALID_OPTIONS;
    
    doc = xmlNewDoc("1.1");
    root=xmlNewChild((xmlNodePtr)doc,NULL,"Temp",NULL);
//    ctx->xsins = xmlNewNs(NULL, options->xsi_namespace, "xsi");
    ctx->xsins = xmlNewNs(root, options->xsi_namespace, "xsi");
//    ctx->opcns = xmlNewNs(NULL, options->opc_namespace, NULL);
    ctx->opcns = NULL;
    
    return 0;
}

int opcFormatOPCXMLFreeContext(OPCFormatOPCXMLContext ctx) {
    if (ctx->xsins) xmlFreeNs(ctx->xsins);
    if (ctx->opcns) xmlFreeNs(ctx->opcns);
}
