#include <dslib.h>

#include <dsdebug.h>
#include <dslocale.h>
#include <dserror.h>
#include <dsxml.h>
#include <dssignal.h>
#include <dsthread.h>
#include <dsconnection.h>
#include <dsconnectionserver.h>
#include <dstime.h>

int dsLibInit() {
    int err;
    
    err=dsMallocInit();
    if (!err) err=dsDebugInit();
    if (!err) err=dsLibTimeInit();
    if (!err) err=dsErrorInit();
    if (!err) err=dsLocaleInit();
    if (!err) err=dsXmlInit();
    if (!err) err=dsSignalInit();
    if (!err) err=dsThreadInit();
    if (!err) err=dsConnectionServerInit();
    if (!err) err=dsConnectionInit();

    return err;
}

void dsLibFree() {
    dsConnectionDestroy();
    dsConnectionServerDestroy();
    dsThreadDestroy();
    dsSignalDestroy();
    dsXmlDestroy();
    dsLocaleDestroy();
    dsErrorDestroy();
    dsLibTimeFree();
    dsDebugDestroy();
    dsMallocDestroy();
}
