#ifndef _OPC_PROPERTY_H
#define _OPC_PROPERTY_H

#include <dsmalloc.h>
#include <dslocale.h>
#include <opctype.h>
#include <opcstandardtype.h>

typedef struct OPCPropertyContextT *OPCPropertyContext;

struct OPCPropertyContextT {
    char *name;
    dslchar description;
    char *xmlnamespace;
    unsigned short int id;
    OPCType type;
    DSMallocContext malloc;
};


OPCPropertyContext opcPropertyCreateContext(DSMallocContext mctx);
int opcPropertyInitContext(OPCPropertyContext ctx, const char *name,  OPCStandardType datatype, const void *attr);
int opcPropertyInitContextByType(OPCPropertyContext ctx, const char *name, OPCType type);
void opcPropertyFreeContext(OPCPropertyContext ctx);
void opcPropertyDestroyContext(OPCPropertyContext ctx);

int opcPropertySetNamespace(OPCPropertyContext ctx, const char *xmlnamespace);
int opcPropertySetId(OPCPropertyContext ctx, unsigned short int id);
int opcPropertySetDescription(OPCPropertyContext ctx, const char *description);

#endif /* _OPC_PROPERTY_H */
